regina::NGraphPair Class Reference
Standard 3-Manifolds

Represents a closed graph manifold formed by joining two bounded Seifert fibred spaces along a common torus. More...

`#include <manifold/ngraphpair.h>`

Inheritance diagram for regina::NGraphPair:

## Public Member Functions

| NGraphPair (NSFSpace *sfs0, NSFSpace *sfs1, long mat00, long mat01, long mat10, long mat11)
| Creates a new graph manifold as a pair of joined Seifert fibred spaces. More...
| NGraphPair (NSFSpace *sfs0, NSFSpace *sfs1, const NMatrix2 &matchingReln)
| Creates a new graph manifold as a pair of joined Seifert fibred spaces. More...
| ~NGraphPair ()
| Destroys this structure along with the component Seifert fibred spaces and the matching matrix. More...
const NSFSpace & | sfs (unsigned which) const
| Returns a reference to one of the two bounded Seifert fibred spaces that are joined together. More...
const NMatrix2 & | matchingReln () const
| Returns a reference to the 2-by-2 matrix describing how the two Seifert fibred spaces are joined together. More...
bool | operator< (const NGraphPair &compare) const
| Determines in a fairly ad-hoc fashion whether this representation of this space is "smaller" than the given representation of the given space. More...
NAbelianGroup * | getHomologyH1 () const
| Returns the first homology group of this 3-manifold, if such a routine has been implemented. More...
bool | isHyperbolic () const
| Returns whether or not this is a finite-volume hyperbolic manifold. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the common name of this 3-manifold as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the common name of this 3-manifold in TeX format to the given output stream. More...
std::string | getName () const
| Returns the common name of this 3-manifold as a human-readable string. More...
std::string | getTeXName () const
| Returns the common name of this 3-manifold in TeX format. More...
std::string | getStructure () const
| Returns details of the structure of this 3-manifold that might not be evident from its common name. More...
virtual NTriangulation * | construct () const
| Returns a triangulation of this 3-manifold, if such a construction has been implemented. More...
bool | operator< (const NManifold &compare) const
| Determines in a fairly ad-hoc fashion whether this representation of this 3-manifold is "smaller" than the given representation of the given 3-manifold. More...
virtual std::ostream & | writeStructure (std::ostream &out) const
| Writes details of the structure of this 3-manifold that might not be evident from its common name to the given output stream. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
virtual void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
Input and Output
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Detailed Description

Represents a closed graph manifold formed by joining two bounded Seifert fibred spaces along a common torus.

Each Seifert fibred space must have just one boundary component, corresponding to a puncture in the base orbifold (with no fibre-reversing twist as one travels around this boundary).

The way in which the two spaces are joined is specified by a 2-by-2 matrix M. This matrix expresses the locations of the fibres and base orbifold of the second Seifert fibred space in terms of the first.

More specifically, suppose that f0 and o0 are generators of the common torus, where f0 represents a directed fibre in the first Seifert fibred space and o0 represents the oriented boundary of the corresponding base orbifold. Likewise, let f1 and o1 be generators of the common torus representing a directed fibre and the base orbifold of the second Seifert fibred space. Then the curves f0, o0, f1 and o1 are related as follows:

        [f1]       [f0]
        [  ] = M * [  ]
        [o1]       [o0]

See the page on Notation for Seifert fibred spaces for details on some of the terminology used above.

The optional NManifold routine getHomologyH1() is implemented, but the optional routine construct() is not.

Todo:
  Optimise: Speed up homology calculations involving orientable base spaces by adding rank afterwards, instead of adding generators for genus into the presentation matrix.

## Constructor & Destructor Documentation

regina::NGraphPair::NGraphPair | ( | NSFSpace * | sfs0,
|  | NSFSpace * | sfs1,
|  | long | mat00,
|  | long | mat01,
|  | long | mat10,
|  | long | mat11
| ) |  |

inline

Creates a new graph manifold as a pair of joined Seifert fibred spaces.

The two bounded Seifert fibred spaces and the four elements of the 2-by-2 matching matrix are all passed separately. The elements of the matching matrix combine to give the full matrix M as follows:

              [ mat00  mat01 ]
        M  =  [              ]
              [ mat10  mat11 ]

Note that the new object will take ownership of the two given Seifert fibred spaces, and when this object is destroyed the Seifert fibred spaces will be destroyed also.

Precondition
  Each Seifert fibred space has a single torus boundary, corresponding to a single untwisted puncture in the base orbifold.
  The given matching matrix has determinant +1 or -1.

Parameters

  sfs0 | the first Seifert fibred space.
  sfs1 | the second Seifert fibred space.
  mat00 | the (0,0) element of the matching matrix.
  mat01 | the (0,1) element of the matching matrix.
  mat10 | the (1,0) element of the matching matrix.
  mat11 | the (1,1) element of the matching matrix.

regina::NGraphPair::NGraphPair | ( | NSFSpace * | sfs0,
|  | NSFSpace * | sfs1,
|  | const NMatrix2 & | matchingReln
| ) |  |

inline

Creates a new graph manifold as a pair of joined Seifert fibred spaces.

The two bounded Seifert fibred spaces and the entire 2-by-2 matching matrix are each passed separately.

Note that the new object will take ownership of the two given Seifert fibred spaces, and when this object is destroyed the Seifert fibred spaces will be destroyed also.

Precondition
  Each Seifert fibred space has a single torus boundary, corresponding to a single untwisted puncture in the base orbifold.
  The given matching matrix has determinant +1 or -1.

Parameters

  sfs0 | the first Seifert fibred space.
  sfs1 | the second Seifert fibred space.
  matchingReln | the 2-by-2 matching matrix.

regina::NGraphPair::~NGraphPair | ( |  | ) |

Destroys this structure along with the component Seifert fibred spaces and the matching matrix.

## Member Function Documentation

NTriangulation * regina::NManifold::construct | ( |  | ) | const

inline virtual inherited

Returns a triangulation of this 3-manifold, if such a construction has been implemented.

If no construction routine has yet been implemented for this 3-manifold (for instance, if this 3-manifold is a Seifert fibred space with sufficiently many exceptional fibres) then this routine will return 0.

The details of which 3-manifolds have construction routines can be found in the notes for the corresponding subclasses of NManifold. The default implemention of this routine returns 0.

Returns
  a triangulation of this 3-manifold, or 0 if the appropriate construction routine has not yet been implemented.

Reimplemented in regina::NSFSpace, regina::NSnapPeaCensusManifold, regina::NLensSpace, and regina::NSimpleSurfaceBundle.

std::string regina::ShareableObject::detail | ( |  | ) | const

inherited

Returns the output from writeTextLong() as a string.

Returns
  a long text representation of this object.

NAbelianGroup* regina::NGraphPair::getHomologyH1 | ( |  | ) | const

virtual

Returns the first homology group of this 3-manifold, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this 3-manifold then this routine will return 0.

The details of which 3-manifolds have homology calculation routines can be found in the notes for the corresponding subclasses of NManifold. The default implemention of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the first homology group of this 3-manifold, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented from regina::NManifold.

std::string regina::NManifold::getName | ( |  | ) | const

inherited

Returns the common name of this 3-manifold as a human-readable string.

Returns
  the common name of this 3-manifold.

std::string regina::NManifold::getStructure | ( |  | ) | const

inherited

Returns details of the structure of this 3-manifold that might not be evident from its common name.

For instance, for an orbit space S^3/G this routine might return the full Seifert structure.

This routine may return the empty string if no additional details are deemed necessary.

Returns
  a string describing additional structural details.

std::string regina::NManifold::getTeXName | ( |  | ) | const

inherited

Returns the common name of this 3-manifold in TeX format.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Returns
  the common name of this 3-manifold in TeX format.

bool regina::NGraphPair::isHyperbolic | ( |  | ) | const

inline virtual

Returns whether or not this is a finite-volume hyperbolic manifold.

Returns
  `true` if this is a finite-volume hyperbolic manifold, or `false` if not.

Implements regina::NManifold.

const NMatrix2 & regina::NGraphPair::matchingReln | ( |  | ) | const

inline

Returns a reference to the 2-by-2 matrix describing how the two Seifert fibred spaces are joined together.

See the class notes for details on precisely how this matrix is represented.

Returns
  a reference to the matching matrix.

bool regina::NManifold::operator< | ( | const NManifold & | compare | ) | const

inherited

Determines in a fairly ad-hoc fashion whether this representation of this 3-manifold is "smaller" than the given representation of the given 3-manifold.

The ordering imposed on 3-manifolds is purely aesthetic on the part of the author, and is subject to change in future versions of Regina.

The ordering also depends on the particular representation of the 3-manifold that is used. As an example, different representations of the same Seifert fibred space might well be ordered differently.

All that this routine really offers is a well-defined way of ordering 3-manifold representations.

Warning
  Currently this routine is only implemented in full for closed 3-manifolds. For most classes of bounded 3-manifolds, this routine simply compares the strings returned by getName().

Parameters

  compare | the 3-manifold representation with which this will be compared.

Returns
  `true` if and only if this is "smaller" than the given 3-manifold representation.

bool regina::NGraphPair::operator< | ( | const NGraphPair & | compare | ) | const

Determines in a fairly ad-hoc fashion whether this representation of this space is "smaller" than the given representation of the given space.

The ordering imposed on graph manifolds is purely aesthetic on the part of the author, and is subject to change in future versions of Regina. It also depends upon the particular representation, so that different representations of the same space may be ordered differently.

All that this routine really offers is a well-defined way of ordering graph manifold representations.

Parameters

  compare | the representation with which this will be compared.

Returns
  `true` if and only if this is "smaller" than the given graph manifold representation.

const NSFSpace & regina::NGraphPair::sfs | ( | unsigned | which | ) | const

inline

Returns a reference to one of the two bounded Seifert fibred spaces that are joined together.

Parameters

  which | 0 if the first Seifert fibred space is to be returned, or 1 if the second space is to be returned.

Returns
  a reference to the requested Seifert fibred space.

std::string regina::ShareableObject::str | ( |  | ) | const

inherited

Returns the output from writeTextShort() as a string.

Python:
  This implements the `__str__()` function.

Returns
  a short text representation of this object.

std::string regina::ShareableObject::toString | ( |  | ) | const

inline inherited

A deprecated alias for str(), which returns the output from writeTextShort() as a string.

Deprecated:
  This routine has (at long last) been deprecated; use the simpler-to-type str() instead.

Returns
  a short text representation of this object.

std::string regina::ShareableObject::toStringLong | ( |  | ) | const

inline inherited

A deprecated alias for detail(), which returns the output from writeTextLong() as a string.

Deprecated:
  This routine has (at long last) been deprecated; use the simpler-to-type detail() instead.

Returns
  a long text representation of this object.

std::ostream& regina::NGraphPair::writeName | ( | std::ostream & | out | ) | const

virtual

Writes the common name of this 3-manifold as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NManifold.

std::ostream & regina::NManifold::writeStructure | ( | std::ostream & | out | ) | const

inline virtual inherited

Writes details of the structure of this 3-manifold that might not be evident from its common name to the given output stream.

For instance, for an orbit space S^3/G this routine might write the full Seifert structure.

This routine may write nothing if no additional details are deemed necessary. The default implementation of this routine behaves in this way.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Reimplemented in regina::NSFSpace, and regina::NSnapPeaCensusManifold.

std::ostream& regina::NGraphPair::writeTeXName | ( | std::ostream & | out | ) | const

virtual

Writes the common name of this 3-manifold in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NManifold.

void regina::NManifold::writeTextLong | ( | std::ostream & | out | ) | const

inline virtual inherited

Writes this object in long text format to the given output stream.

The output should provide the user with all the information they could want. The output should be human-readable, should not contain extremely long lines (so users can read the output in a terminal), and should end with a final newline.

The default implementation of this routine merely calls writeTextShort() and adds a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::ShareableObject.

void regina::NManifold::writeTextShort | ( | std::ostream & | out | ) | const

inline virtual inherited

Writes this object in short text format to the given output stream.

The output should be human-readable, should fit on a single line, and should not end with a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Implements regina::ShareableObject.

The documentation for this class was generated from the following file:

- manifold/ngraphpair.h

Copyright © 1999-2014, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).